local fntPR, fntPG, fntPB, fntPS;
local fscale = 40;

function Coords_OnLoad()
    SLASH_Coords1 = "/Coords";
    SlashCmdList["Coords"] = Coords_SlashHandler;
    CoordsFrame:RegisterEvent("ADDON_LOADED");
	CoordsFrame:RegisterEvent( "PLAYER_ENTERING_WORLD" );
	CoordsFrame:RegisterEvent( "ZONE_CHANGED" );
	CoordsFrame:RegisterEvent( "ZONE_CHANGED_NEW_AREA" );
	CoordsFrame:RegisterEvent( "ZONE_CHANGED_INDOORS" );
end
 
function Coords_SlashHandler(arg1)
   if (string.trim(string.lower(arg1)) == "") then		
    DEFAULT_CHAT_FRAME:AddMessage("use /coords resetpos - for return coords to default position", 0,1,0);
    DEFAULT_CHAT_FRAME:AddMessage("use /coords sf - for setup font size and color", 0,1,0);
    DEFAULT_CHAT_FRAME:AddMessage("use /coords rf - for return font settings to default", 0,1,0);
    DEFAULT_CHAT_FRAME:AddMessage("or press alt+click on coords frame and move it freely", 0,1,0);
   end

   if (string.lower(arg1) == "resetpos") then		
      CoordsFrame:ClearAllPoints();
	  CoordsFrame:SetPoint("RIGHT", Minimap, "RIGHT", -180, 87);
   end
   
   if (string.lower(arg1) == "sf") then

	  fntPR, fntPG, fntPB = CoordsText:GetTextColor();
	  fntPS = fntS;
	  
      OpacitySliderFrame:SetMinMaxValues(10, fscale - 10);
      OpacitySliderFrame:SetValueStep(1);

	  ColorPickerFrame:SetColorRGB(fntPR, fntPG, fntPB);     
      ColorPickerFrame.hasOpacity = true;
      ColorPickerFrame.opacity = fntPS; 
      ColorPickerFrame.func = function() fntR, fntG, fntB = ColorPickerFrame:GetColorRGB(); fntS = OpacitySliderFrame:GetValue(); Coords_fnt_set(fntR, fntG, fntB, fntS); end;
      ColorPickerFrame.opacityFunc = function() fntR, fntG, fntB = ColorPickerFrame:GetColorRGB(); fntS = OpacitySliderFrame:GetValue(); Coords_fnt_set(fntR, fntG, fntB, fntS); end;
      ColorPickerFrame.cancelFunc = function() OpacitySliderFrame:SetValue(fntPS); Coords_fnt_set(fntPR, fntPG, fntPB, fntPS); end;
      ColorPickerFrame:Hide();
      ColorPickerFrame:Show();      
   end
   
    if (string.lower(arg1) == "rf") then
        Coords_fnt_reset();
    end  
end

function Coords_OnEvent(event)
    if event == "ADDON_LOADED" then
        if fntS == nil then
            Coords_fnt_reset();
        end

        CoordsText:SetTextColor(fntR, fntG, fntB);
        f = fscale - fntS;
        CoordsText:SetFont("Fonts\\FRIZQT__.TTF", f, 0);
    end
end

function Coords_OnUpdate() 
   fcolor = CoordsText:GetTextColor();
   
	local px, py
	local mapID = C_Map.GetBestMapForUnit("player")
	local mapPos = mapID and C_Map.GetPlayerMapPosition(mapID, "player")
	if mapPos then 
		px, py = mapPos:GetXY() 
	else
		px = 0
		py = 0
	end 
      
   CoordsText:SetText(format("X: %.2f Y: %.2f", px * 100, py * 100));
end

function Coords_fnt_set(r, g, b, s)
    CoordsText:SetTextColor(r, g, b);    
    f = fscale - s;      
    CoordsText:SetFont("Fonts\\FRIZQT__.TTF", f, 0);
end

function Coords_fnt_reset()
    fntR = 1;
    fntG = 0.8;
    fntB = 0;
    fntS = fscale - 10;
    Coords_fnt_set(fntR, fntG, fntB, fntS);
end